
odrv0.vbus_voltage

############################################################# INI 1 liten motor 20480
odrv0.axis1.motor.config.current_lim = 50 # Overordnet
odrv0.axis1.controller.config.vel_limit = 50 # Overordnet
odrv0.axis1.motor.config.torque_constant = 8.27/192 # 8.27 / 90 (8.27/KT)
odrv0.axis1.motor.config.motor_type = MOTOR_TYPE_HIGH_CURRENT
odrv0.axis1.encoder.config.cpr = 20480
odrv0.axis1.motor.config.calibration_current = 10 # under kalibrering
odrv0.axis1.encoder.config.use_index = True
odrv0.config.brake_resistance = 2
odrv0.axis1.motor.config.pole_pairs = 7 #20
odrv0.config.dc_max_negative_current = -1

odrv0.axis1.trap_traj.config.accel_limit = 10 # 45 # For trapes
odrv0.axis1.trap_traj.config.vel_limit = 25 # 35 # For trapes 
odrv0.axis1.trap_traj.config.decel_limit = 10 # 45 # For trapes
odrv0.axis1.controller.config.pos_gain = 40 # 180 # strammhet
odrv0.axis1.controller.config.vel_gain = 0.25 # turn/s
odrv0.axis1.controller.config.vel_integrator_gain = 0.01 # accelerasjon?
odrv0.axis1.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ # God og lur å ha

odrv0.axis1.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv1.save_configuration() # Ikke bry seg om feilmelding

###########################################################
#############################################################
#############################################################

from datetime import datetime
import time
import math 

dT = 2000 # samplings intervall us, 500Hz
f = 0.1   # Hz for sinus eksemplet 


# sin kanal 1 ja
f = 0.5   # Hz for sinus eksemplet 
periodNoNow = 0
periodNoOld = 0 
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*20): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis1.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000) 
odrv0.axis1.controller.input_pos = 0
odrv0.axis1.requested_state = AXIS_STATE_IDLE

# sin kanal 1 skew1

f = 0.5   # Hz for sinus eksemplet 
c = 0.75 
periodNoNow = 0
periodNoOld = 0 
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*15): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis1.controller.input_pos = 0.1* (1.0/c) * math.atan( c*math.sin( 2*math.pi*f*t/1000000 ) / (1 - c*math.cos(2*math.pi*f*t/1000000)) )
odrv0.axis1.controller.input_pos = 0
odrv0.axis1.requested_state = AXIS_STATE_IDLE

# sin kanal 1 skew2 ja

f = 0.5   # Hz for sinus eksemplet 
c = 0.75 
periodNoNow = 0
periodNoOld = 0 
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*15): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis1.controller.input_pos = 0.15* (math.pow(math.cos(2*math.pi*f*t/1000000 ),8) -0.5)
odrv0.axis1.controller.input_pos = 0
odrv0.axis1.requested_state = AXIS_STATE_IDLE


#################################
# sin kanal 1 skew3

f = 0.5   # Hz for sinus eksemplet 
c = 0.75 
periodNoNow = 0
periodNoOld = 0 
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*15): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis1.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000 + math.cos(10*2*math.pi*f*t/1000000)/5) 
odrv0.axis1.requested_state = AXIS_STATE_IDLE


# sin kanal 1 skew5

f = 1   # Hz for sinus eksemplet 
c = 0.75 
periodNoNow = 0
periodNoOld = 0 
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*15): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis1.controller.input_pos = 0.1* math.pow(math.cos((1/12)*2*math.pi*f*t/1000000),4) * math.sin(2*math.pi*f*t/1000000) 
odrv0.axis1.requested_state = AXIS_STATE_IDLE





periodNoNow = 0
periodNoOld = 0 
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*20): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis0.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000)  + 0.07*math.sin(4*math.pi*f*t/1000000)
odrv0.axis0.requested_state = AXIS_STATE_IDLE

periodNoNow = 0
periodNoOld = 0 
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*20): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis1.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000)  + 0.07*math.sin(4*math.pi*f*t/1000000)
odrv0.axis1.requested_state = AXIS_STATE_IDLE

periodNoNow = 0
periodNoOld = 0 
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
odrv0.axis1.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
for sampNr in range(500*20): # 10sec, 5000sampler
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond # usec
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    odrv0.axis0.controller.input_pos = 0.1*math.sin(2*math.pi*f*t/1000000)  + 0.07*math.sin(4*math.pi*f*t/1000000)
    odrv0.axis1.controller.input_pos = -0.1*math.sin(2*math.pi*f*t/1000000)  - 0.07*math.sin(4*math.pi*f*t/1000000)
odrv0.axis0.requested_state = AXIS_STATE_IDLE
odrv0.axis1.requested_state = AXIS_STATE_IDLE





