function [corArrDB] = swapMov(corFile, movOrg, movNew)
    % Bytter både på fil og i minne
    
    corArrDB = readcell(corFile);
    corArrDB(cellfun(@(x) any(ismissing(x)), corArrDB)) = {''};
    
    noDB = length(corArrDB);
    
    for i = 1 : noDB
        mov = corArrDB{i, 2};
        
        if strcmp(mov, movOrg) == 1
            corArrDB{i, 2} = movNew;
        end
        
    end
    
    writecell(corArrDB, corFile);
    
end